/*
 * CS356 Project 01 -- Elevator Simulator
 *
 * Position Class Specification
 */

#ifndef POSITION_HPP
#define POSITION_HPP

#include <iostream>

class Position
{
	friend std::ostream& operator<< (std::ostream& os, const Position& rhs);

	public:
		Position ();
		Position (int initial_position);

		Position& operator+= (const float rhs);
		Position& operator-= (const float rhs);

		bool operator== (const Position& rhs) const;
		bool operator!= (const Position& rhs) const;
		bool operator< (const Position& rhs) const;
		bool operator> (const Position& rhs) const;
		Position operator- (const Position& rhs) const;
		operator float() const;


	private:
		int major_;
		int minor_;
};

#endif /* POSITION_HPP */

/* vim: set ts=4 sts=4 sw=4 noexpandtab textwidth=112: */
