#include <iostream>
#include <list>
#include <unistd.h>
using namespace std;

#include "stop.hpp"
#include "position.hpp"
#include "elevator.hpp"
#include "elevatorcontroller.hpp"
#include "elevatorgui.hpp"

#include <gtkmm/main.h>


int main (int argc, char *argv[])
{
	const int floors = 7;
	const int elevators = 3;

	// Start GTK
	Gtk::Main app(argc, argv);

	ElevatorGUI eg(floors, elevators);
	eg.show ();

	Gtk::Main::run (eg);



#if TEST_ELEVATORCONTROLLER
	const int floors = 10;
	const int elevators = 2;

	ElevatorController ec(floors, elevators);

	//ec.elevator_request (0, 2);
	ec.call_elevator_to (3, DOWN);

	for (int i=0; i<35; i++)
		ec.move_elevators ();

	// Note: without the GUI, this is dependent on choosing the same elevator
	// that was randomly chosen by the call_elevator_to() funtion.
	//
	// This may need to be run a few times to work :)
	ec.elevator_request (0, 2);

	for (int i=0; i<35; i++)
		ec.move_elevators ();
#endif


#if TEST_ELEVATOR
	Elevator e(2);

	Stop s2(3, DOWN);
	e.stop_at (s2);

	Stop s3(1, UP);
	e.stop_at (s3);

	Stop s4(4, DOWN);
	e.stop_at (s4);

	Stop s5(5, ALL);
	e.stop_at (s5);

	for (int i=0; i<100; ++i)
	{
		usleep (500000);
		e.move ();
	}
#endif

	return 0;
}

/* vim: set ts=4 sts=4 sw=4 noet tw=112: */
